#	include	"Simulator.h"

Component	::	Component(
	char	*theName)
	{
	Name = NULL;
	if(theName)
		SetName(theName);
	}

Component	::	~Component()
	{
	SetName(NULL);
	}

bool
Component	::	SetName(
	char	*NewName)
	{
	if(Name)
		delete Name;
	Name = NULL;
	if(NewName)
		{
		Name = new char[strlen(NewName)+1];
		strcpy(Name, NewName);
		}
	return(true);
	}

char	*
Component	::	GetName()
	{
	if(Name)
		return(Name);
	return("No Name");
	}

bool
Component	::	PrintValueFirstPart(
	int		Format,
	FILE	*fp,
	char	*StatName)
	{
	if(Format==HumanFormat)
		{
		fprintf(fp, "%30s:%30s:", GetName(), StatName);
		}
	else
	if(Format==MachineFormat)
		{
		fprintf(fp, "%s_%s ", GetName(), StatName);
		}
	return(true);
	}

bool
Component	::	PrintValueLastPart(
	int		Format,
	FILE	*fp)
	{
	if(Format==HumanFormat)
		{
		fprintf(fp, "\n");
		}
	else
	if(Format==MachineFormat)
		{
		fprintf(fp, " ");
		}
	return(true);
	}

bool
Component	::	PrintPercent(
	int		Format,
	FILE	*fp,
	char	*StatName,
	Counter	InValue,
	Counter	OutValue)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%.2f%%", (100.0*(double)InValue)/((double)(InValue+OutValue)));
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	int		Format,
	FILE	*fp,
	char	*StatName,
	Counter	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%lld", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	int		Format,
	FILE	*fp,
	char	*StatName,
	int		Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%d", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	int		Format,
	FILE	*fp,
	char	*StatName,
	uint	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%u", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

bool
Component	::	PrintValue(
	int		Format,
	FILE	*fp,
	char	*StatName,
	uint32	Value)
	{
	PrintValueFirstPart(Format, fp, StatName);
	fprintf(fp, "%u", Value);
	PrintValueLastPart(Format, fp);
	return(true);
	}

