#	include	"Simulator.h"


// Unfortuantly, there are some global tables that
// are needed by ss.def to make things happen.  We
// put these global tables here... Some of these where derived in
// the nastess of ways.  My apoligies.

#	define	XX	0x6bababab

uint	Processor	::	NumberOfActiveProcessors = 0;

int	SimPreStepTable[8][5]	=
	{
					/* NOP   POSTI POSTD  PREI   PRED */
	/* byte */		{	0,	0,	0,	1,	-1	},
	/* half */		{	0,	0,	0,	2,	-2	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* word */		{	0,	0,	0,	4,	-4	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* dword */		{	0,	0,	0,	8,	-8	}
	};

int	SimPostStepTable[8][5]	=
	{
					/*	NOP   POSTI POSTD  PREI   PRED */
	/* byte */		{	0,	1,	-1,	0,	0	},
	/* half */		{	0,	2,	-2,	0,	0	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* word */		{	0,	4,	-4,	0,	0	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* invalid */	{	XX,	XX,	XX,	XX,	XX	},
	/* dword */		{	0,	8,	-8,	0,	0	}
	};

unsigned	int	SimLRMasks[]	=
	{
#ifdef BYTES_BIG_ENDIAN
	0x00000000,
	0x000000ff,
	0x0000ffff,
	0x00ffffff,
	0xffffffff,
#else
	0xffffffff,
	0x00ffffff,
	0x0000ffff,
	0x000000ff,
	0x00000000,
#endif
	};

enum	SimOpCode	SimMaskToOpCode[SS_MAX_MASK+1];


bool	InitializeSimMaskToOpCodeTable()
	{
#define DEFINST(TICKS, OP,MSK,NAME,OPFORM,RES,FLAGS,O1,O2,I1,I2,I3,EXPR)    \
		SimMaskToOpCode[(MSK)]=(OP);
#include "ss.def"
#undef DEFINST
	return ( true );
	}

char	*SimOpCodeToName[MaxOpCode]	=
	{
	NULL,
#define DEFINST(TICKS, OP,MSK,NAME,OPFORM,RES,FLAGS,O1,O2,I1,I2,I3,EXPR) NAME,
#define DEFLINK(OP,MSK,NAME,MASK,SHIFT) NAME,
#define CONNECT(OP)
#include "ss.def"
#undef DEFINST
#undef DEFLINK
#undef CONNECT
	};

char	*SimOpCodeToFormat[]	=
	{
	NULL,
#define DEFINST(TICKS, OP,MSK,NAME,OPFORM,RES,FLAGS,O1,O2,I1,I2,I3,EXPR) OPFORM,
#define DEFLINK(OP,MSK,NAME,MASK,SHIFT) NULL,
#define CONNECT(OP)
#include "ss.def"
#undef DEFINST
#undef DEFLINK
#undef CONNECT
	};

#define	NA	FUClass_NA
enum	SimFunctionalUnitClass	SimOpCodeToFunctionalUnitClass[]	=
	{
	FUClass_NA,
#define DEFINST(TICKS,OP,MSK,NAME,OPFORM,RES,FLAGS,O1,O2,I1,I2,I3,EXPR) RES,
#define DEFLINK(OP,MSK,NAME,MASK,SHIFT) FUClass_NA,
#define CONNECT(OP)
#include "ss.def"
#undef DEFINST
#undef DEFLINK
#undef CONNECT
	};

uint	SimOpCodeToFlags[MaxOpCode]	=
	{
	0,
#define DEFINST(TICKS,OP,MSK,NAME,OPFORM,RES,FLAGS,O1,O2,I1,I2,I3,EXPR) FLAGS,
#define DEFLINK(OP,MSK,NAME,MASK,SHIFT) NA,
#define CONNECT(OP)
#include "ss.def"
#undef DEFINST
#undef DEFLINK
#undef CONNECT
	};

char	*SimFunctionalUnitClassToName[]	=
	{
	NULL,
	"fu-int-ALU",
	"fu-int-multiply",
	"fu-int-divide",
	"fu-FP-add/sub",
	"fu-FP-comparison",
	"fu-FP-conversion",
	"fu-FP-multiply",
	"fu-FP-divide",
	"fu-FP-sqrt",
	"rd-port",
	"wr-port"
	};


bool
Processor	::	DumpInstruction (
	SimInstruction	*CurrentInstruction)
	{
	if(!CurrentInstruction)	return ( false );
	enum	SimOpCode	op;
	FILE	*stream = stdout;

	if(CurrentInstruction->ui[0]==0xffffffff)
		{
		fprintf(stream, "*** Invalid Op Code ***");
		return(false);
		}
	op = SS_OP_ENUM(SimInstructionOpCode(CurrentInstruction));

	if (op >= MaxOpCode)
		{
		fprintf(stream, "<invalid inst: 0x%08x:%08x>",
			CurrentInstruction->ui[0],
			CurrentInstruction->ui[1]);
		}
	else
		{
		char *s;
		fprintf(stream, "%-10s", SS_OP_NAME(op));
		s = SS_OP_FORMAT(op);
		while (*s)
			{
			switch (*s)
				{
				case 'd': fprintf(stream, "r%d", RD ); break;
				case 's': fprintf(stream, "r%d", RS ); break;
				case 't': fprintf(stream, "r%d", RT ); break;
				case 'b': fprintf(stream, "r%d", BS); break;
				case 'D': fprintf(stream, "f%d", FD); break;
				case 'S': fprintf(stream, "f%d", FS); break;
				case 'T': fprintf(stream, "f%d", FT); break;
				case 'j': fprintf(stream, "pc + 0x%x", (8 + (OFS << 2))); break;
				case 'o':
				case 'i': fprintf(stream, "%d", IMM); break;
				case 'H': fprintf(stream, "%d", SHAMT); break;
				case 'u': fprintf(stream, "%u", UIMM); break;
				case 'U': fprintf(stream, "0x%x", UIMM); break;
				case 'J':
					fprintf(stream,
						//"0x%x", ((pc & 036000000000) | (TARG << 2)));
						"0x%x", ((TARG << 2)));
					break;
				case 'B': fprintf(stream, "0x%x", BCODE); break;
				/*
				case ')':
					if (SS_COMP_OP == SS_COMP_NOP)
						fprintf(stream, ")");
					else if (SS_COMP_OP == SS_COMP_POST_INC)
						fprintf(stream, ")+");
					else if (SS_COMP_OP == SS_COMP_POST_DEC)
						fprintf(stream, ")-");
					else if (SS_COMP_OP == SS_COMP_PRE_INC)
						fprintf(stream, ")^+");
					else if (SS_COMP_OP == SS_COMP_PRE_DEC)
						fprintf(stream, ")^-");
					else if (SS_COMP_OP == SS_COMP_POST_DBL_INC)
						fprintf(stream, ")++");
					else if (SS_COMP_OP == SS_COMP_POST_DBL_DEC)
						fprintf(stream, ")--");
					else if (SS_COMP_OP == SS_COMP_PRE_DBL_INC)
						fprintf(stream, ")^++");
					else if (SS_COMP_OP == SS_COMP_PRE_DBL_DEC)
						fprintf(stream, ")^--");
				*/
				default:
					fputc(*s, stream);
				}
			++s;
			}
		}
	return ( true );
	}


