// Abstract notion of a Simple-scalar processor

extern	bool	InitializeSimMaskToOpCodeTable();

class	Processor	:
	public	Component
	{
	public:
		static	uint		NumberOfActiveProcessors;
		uint				ProcessorNumber;
	public:
		virtual	SimRegister	*GetIntegerRegisterSet() = 0;
		virtual	SimRegister	*GetFloatingPointRegisterSet() = 0;
		virtual	SimRegister	*GetHigh() = 0;
		virtual	SimRegister	*GetLow() = 0;
		virtual	SimRegister	*GetProgramCounter() = 0;
		virtual	SimRegister	*GetFloatingPointConditionalFlags() = 0;
		virtual	SimSingle	*GetFloatingPointRegisterSetAsSingle() = 0;
		virtual	SimDouble	*GetFloatingPointRegisterSetAsDouble() = 0;
		virtual	MemorySystem	*GetDataMemorySystem() = 0;
		virtual	MemorySystem	*GetInstructionMemorySystem() = 0;
		virtual	bool	DumpInstruction(SimInstruction	*si);
		virtual	bool	Halt() = 0;

		virtual	uint8	ReadDataMemory8(SimAddress) = 0;
		virtual	uint16	ReadDataMemory16(SimAddress) = 0;
		virtual	uint32	ReadDataMemory32(SimAddress) = 0;
		virtual	bool	WriteDataMemory8(SimAddress, uint8) = 0;
		virtual	bool	WriteDataMemory16(SimAddress, uint16) = 0;
		virtual	bool	WriteDataMemory32(SimAddress, uint32) = 0;
	};

