
class	StandardDRAMDevice	:
	public	MemorySystem
	{
	public:
		uint32		Pages;
		uint32		PageSize;
		uint32		AccessLatency;
		uint32		TransferRate;
		uint32		PageShift;
		uint32		PageMask;
		int			Transacting;
		Resource	DRAM;
		Resource	FrontSideBus;
		Component	*UpStreamComponent;
		Counter		Accesses;
		Counter		BytesRead;
		Counter		BytesWritten;
		Counter		BusBusyCycles;
		Counter		BusIdleCycles;
		Counter		DRAMBusyCycles;
		Counter		DRAMIdleCycles;
	public:
		uint8		**PageArray;

				StandardDRAMDevice();
		virtual		~StandardDRAMDevice();

		bool	PrintConfiguration (int Format=HumanFormat, FILE *fp=stdout);
		bool	PrintStatistics (int Format=HumanFormat, FILE *fp=stdout);

		bool	Clear();
		bool	Initialize(uint32 aPages, uint32 aPageSize,
						uint32	aAccessLatency, uint32	aTransferRate);
		bool	Connect(Component	*c);
		uint8	ReadMemory8(SimAddress);
		uint16	ReadMemory16(SimAddress);
		uint32	ReadMemory32(SimAddress);
		bool	WriteMemory8(SimAddress, uint8);
		bool	WriteMemory16(SimAddress, uint16);
		bool	WriteMemory32(SimAddress, uint32);
	protected:
		uint8	*GetPage(SimAddress);
	public:
		int		SimulateOneClockCycle();
		bool	ScheduleOperation(bool	IsWrite, SimAddress,
					int	Bytes, int	StartAfter,
					int	*UntilStart, int *UntilFinish);
	};

